FROM registry.gitlab.com/buildgrid/buildbox/buildbox-e2e:latest

RUN apt-get update && apt-get install -y \
    docker.io \
    python3-pip \
    time

# Install chrootbuilder
RUN git clone --depth 1 https://gitlab.com/BuildGrid/buildbox/buildbox-tools.git && \
cd buildbox-tools/python/chrootbuilder && pip3 install .

# Pull specifc docker image so digests don't change
ENV DOCK_IMG "frolvlad/alpine-gxx@sha256:a5f206ffb5b4ef2d66dd04128b62c9b3decefb4cdb1931bdfc0f4b987e9a558f"

ENV RECC_BINARY="/buildbox-e2e-build/recc/build/bin/recc"
ENV CASUPLOAD_BINARY="/buildbox-e2e-build/buildbox-tools/cpp/build/casupload/casupload"

ENV USERCHROOT_REPO="https://gitlab.com/BuildGrid/buildbox/buildbox-run-userchroot"
ENV USERCHROOT_REPO_NAME="buildbox-run-userchroot"

RUN mkdir /test
WORKDIR /test

# RECC ENV Variables
ENV RECC_SERVER "controller:50051"
ENV RECC_INSTANCE ""
ENV RECC_PREFIX_MAP="/alpine=/:/dependency=/"
ENV RECC_REMOTE_ENV_PATH="/bin"

# CMAKE ENV Variables
ENV CXX="$RECC_BINARY /usr/bin/g++"

# pull alpine image, build alpine image, upload the image, run command
CMD docker pull $DOCK_IMG && chrootbuilder --extract $DOCK_IMG /alpine && \
$CASUPLOAD_BINARY --cas-server=http://$RECC_SERVER /alpine && \
git clone $USERCHROOT_REPO && \
cd $USERCHROOT_REPO_NAME && \
mkdir -p build && \
cd build && \
cmake .. && \
time make
